#!/usr/bin/env python2.1

import ann
import random
import profile


# define some functions
def ann_gather_results(a, num):
    if num == None:
        return []
    return [(a.get_nnidx(i), a.get_dist(i)) for i in range(num)]

def do_search(a, pt):
    num = a.search(pt, 3)
    return ann_gather_results(a, num)

rg = random.Random(42)
v = 0
def rand():
    #return rg.random()
    global v
    v += 0.1
    return v

def main():
    # make a new ANN-object tree
    a = ann.ANN(100, 3)

    # tell it some points
    a.add_pt([0,0,0])
    a.add_pt([0,0,1])
    a.add_pt([0,1,0])
    a.add_pt([0,1,1])
    a.add_pt([1,0,0])
    a.add_pt([1,0,1])
    a.add_pt([1,1,0])
    a.add_pt([1,1,1])

    # try some searches (each stmt should print a list of n-closest pts)
    print do_search(a, [0.1, 0.1, 0.1])
    print do_search(a, [0.9, 0.9, 0.9])
    print do_search(a, [0.5, 0.5, 0.5])


    ## more difficult test
    print 'Difficult test commencing.'
    dims = 8
    num_pts = 10000
    b = ann.ANN(32000, dims)

    print '  Adding points.'
    for i in range(num_pts):
        b.add_pt([rand() for i in range(dims)])

    print '  Commencing searches.'
    num_srchs = 3
    for i in range(num_srchs):
        pt = [rand() for i in range(dims)]
        print '    NN of', pt, ':'
        print do_search(b, pt)


if __name__ == '__main__':
    main()
    #profile.run('main()', 'ann.prof')
